Subject: Re: WiSH: A General Purpose Message Framing over Byte-Stream Oriented Wire Protocols (HTTP)
From: Van Catha <[email-masked]>
To: Mike Bishop <[email-masked]>
Cc: Poul-Henning Kamp <[email-masked]>, Mark Nottingham <[email-masked]>, Takeshi Yoshino <[email-masked]>, Willy Tarreau <[email-masked]>, Andy Green <[email-masked]>, "[email-masked] Group" <[email-masked]>, Wenbo Zhu <[email-masked]>, Martin Thomson <[email-masked]>
Date: Wed, 30 Nov 2016 22:06:38 -0500
List-Id: <ietf-http-wg.w3.org>

> HTTP/2 makes many of the pre-WebSocket solutions to this problem space
much cheaper.  QUIC will probably make it even more so.
> If there are people who feel strongly that WebSockets still meet a need
over a modern HTTP, I'm happy to read and occasionally comment,
> but I don't feel called to be integral to that work.

At this point I wonder if there is a need for a separate solution.  Making
websockets go over HTTP2 seems to bring up the bureaucratic problems of the
past.  If websocket can be its own thing, then have an implementation for
HTTP2 and another one for QUIC, I think it can see more success.  The
reason for this is both protocols (HTTP2 and QUIC) have their own way of
trammiting data frames.  Websocket in this case should become an
alternative frame type, basically one carrying a binary payload.  All the
previous baggage of websocket1 can be dropped like the distinction between
text/binary frames as well as ping/pong and close. So we end up with just 1
frame type.

Compression would be left up to the client js / server code.  The
websocket2 would be a super simple two way binary stream.

This is pretty self explanatory, the major problem is how you do handle
authentication now.

On Wed, Nov 30, 2016 at 2:29 PM, Mike Bishop <[email-masked]>
wrote:

> QUIC's charter doesn't have anything directly to do with WebSockets.  But
> I agree that since WebSockets came from a different WG, it might be a
> reasonable question to the ADs whether that working group should be
> rechartered to do an HTTP/2 or HTTP/QUIC port.
>
> HTTP/2 makes many of the pre-WebSocket solutions to this problem space
> much cheaper.  QUIC will probably make it even more so.  If there are
> people who feel strongly that WebSockets still meet a need over a modern
> HTTP, I'm happy to read and occasionally comment, but I don't feel called
> to be integral to that work.
>
> -----Original Message-----
> From: Poul-Henning Kamp [mailto:[email-masked]]
> Sent: Sunday, November 27, 2016 1:19 PM
> To: Van Catha <[email-masked]>
> Cc: Mark Nottingham <[email-masked]>; Takeshi Yoshino <[email-masked]>;
> Willy Tarreau <[email-masked]>; Andy Green <[email-masked]>;
> [email-masked] Group <[email-masked]>; Wenbo Zhu <
> [email-masked]>; Martin Thomson <[email-masked]>
> Subject: Re: WiSH: A General Purpose Message Framing over Byte-Stream
> Oriented Wire Protocols (HTTP)
>
> --------
> In message <CAG-EYCiVExcyHLoXB1ixQCKduxUPTVOnV
> [email-masked]>
> , Van Catha writes:
>
> >So can we form a new WG then and focus on doing this right vs making
> >WebSocket2.  The focus earlier was to get the already coded clients and
> >API (websocket API) to be able to work with websockets layered on
> >HTTP2/QUIC, if we are in it for the long haul now we might as well form
> >a new group and create something more long term?
>
> Apologies for asking a stupid question, but isn't that exactly what QUIC
> is all about in the first place ?
>
> --
> Poul-Henning Kamp       | UNIX since Zilog Zeus 3.20
> [email-masked]         | TCP/IP since RFC 956
> FreeBSD committer       | BSD since 4.3-tahoe
> Never attribute to malice what can adequately be explained by incompetence.
>
>